@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:SETUP
	if "%~1" equ "" goto :HELP
	
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_targetdir!"]
		set bat_returncode=1
		goto :DONE
	)
	set bat_archivedfilesdir=!bat_targetdir!
	
	set bat_autonomous=
	if /i "%~2" equ "autonomous" (
		set bat_autonomous="autonomous"
	)
	

:TARGETDIR
	!bat_pushecho!
	!bat_echolog! ========================================================================
	!bat_echolog! [!date! !time!] - !bat_batchfile! %*
	!bat_pushecho!

		rem Get bat_capturedfilesdir from config file.
	call :READCONFIG

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	set bat_outputfile=!bat_targetdir!\meteorcount.txt

	for /f "usebackq tokens=*" %%a in ('"!bat_targetdir!"') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
		set bat_captureddate=!bat_dirdate!
		set bat_archtime=!bat_archdirname:~11,8!
	)
	
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	!bat_log! bat_targetdir=!bat_targetdir!
	!bat_log! bat_targetdrive=!bat_targetdrive!
	!bat_log! bat_outputfile=!bat_outputfile!
	!bat_log! bat_exedir=!bat_exedir!
	!bat_log! bat_dirdate=!bat_dirdate!
	!bat_log! bat_currdate=!bat_currdate!
	!bat_log! bat_capturedfilesdir=!bat_capturedfilesdir!
	!bat_log! bat_camera=!bat_camera!

	if /i "!bat_targetdir!" equ "" (
		!bat_echolog!
		!bat_echolog! The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		!bat_echolog! Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		!bat_echolog!
		if not defined bat_autonomous (
			set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		) else (
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :DONE
		)
		
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)
goto :MAIN %*




:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0

	call :GETDETECTFILE
	!bat_log! bat_returncode=[!bat_returncode!]
	
rem set /p bat_junk=!bat_batchfile!:MAIN - Press ENTER to continue 

	if /i "!bat_returncode!" equ "0" (
		call :APPLYBEGIN
	)
!bat_log! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE



rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLYBEGIN
!bat_pushlog! [CALL !bat_batchfile!:APPLYBEGIN] %*

:APPLY1
!bat_log! [!bat_batchfile!:APPLY1]

	!bat_echolog!
	!bat_echolog!     This step runs FTP_ApplyCal2Detectinfo.exe
	!bat_echolog!

	if not defined bat_autonomous (
		!bat_echolog! You may be given the following instruction:
		!bat_echolog! Navigate to FTP Detection File to Process for Coincidence'.  
		!bat_echolog!
		!bat_echolog! Instead, navigate to and select:
		!bat_echolog!     "!bat_detectfile1!".
		!bat_echolog!
		set bat_choice=
		!bat_log! set /p bat_choice=.!bat_pushstring![A]pply cal, [S]kip, or [Q]uit : 
		set /p bat_choice=.!bat_pushstring![A]pply cal, [S]kip, or [Q]uit : 
		!bat_log! bat_choice=!bat_choice!
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=9
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
		if /i "!bat_choice!" equ "s" (
			!bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfile1!"`^) do...
			for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile1!"`) do (
				set bat_temp=%%a
				if "!bat_temp:~3,3!" equ "!bat_camera!" (
					set bat_calname=%%a
				)
			)

			goto :APPLY4
		)
		if /i "!bat_choice!" neq "a" goto :APPLY1
	)

	find /i ".bin" "!bat_detectfile1!">nul:
	if !errorlevel! neq 0 (
		!bat_echolog! '    ERROR - No events found in "!bat_detectfile1!"
		set bat_returncode=1
		!bat_log! '    set bat_returncode=!bat_returncode!
		goto :APPLY5
	)

	!bat_echolog! *************************************************************
	!bat_echolog! call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"{CRLF.inp
	              call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"<CRLF.inp
	set bat_returncode=!errorlevel!
	!bat_echolog! [bat_returncode=!bat_returncode!] *************************************************************

	!bat_echolog!
	!bat_pushecho! Now checking validity of the outcome...
		set bat_ffname=
		set bat_calname=
		!bat_pushecho! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".bin" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do...
		for                /f "usebackq tokens=* skip=2" %%a in  (`find /i ".bin" "!bat_targetdir!\!bat_detectfile3!C.txt"`) do (
			if not defined bat_ffname (
				rem set bat_temp=%%a
				rem if "!bat_temp:~3,3!" equ "!bat_camera!" (
					!bat_echolog! set bat_ffname=%%a
					              set bat_ffname=%%a
				rem )
			)
		)
		!bat_popecho! ^) // bat_ffname=[!bat_ffname!]
		!bat_echolog!

		if defined bat_ffname (
			!bat_echolog! !bat_ffname!       [The last FF file in the detect file after applying]
		) else (
			!bat_echolog! '    ERROR - Could not find ".bin" files in "!bat_targetdir!\!bat_detectfile3!C.txt"
			set bat_returncode=1
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
		
		!bat_echolog!
	
		if not defined bat_camera (
			!bat_echolog! '    ERROR - no camera number defined
			set bat_camera=!bat_camera_list:~1,3!
		)

		!bat_pushecho! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do...
		for                /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_targetdir!\!bat_detectfile3!C.txt"`) do (
			if not defined bat_calname (
				set bat_temp=%%a
				if "!bat_temp:~3,3!" equ "!bat_camera!" (
					!bat_echolog! set bat_calname=%%a
					              set bat_calname=%%a
				)
			)
		)
		!bat_popecho! ^) // bat_calname=[!bat_calname!]
		!bat_echolog!

		if defined bat_calname (
			!bat_echolog! !bat_calname!      [The current CAL file in the detect file after applying]
		) else (
			!bat_echolog! '    ERROR - Could not find ".txt" files in "!bat_targetdir!\!bat_detectfile3!C.txt"
			set bat_returncode=1
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	

		!bat_echolog!
		!bat_echolog!
		!bat_echolog!   The FF file and the CAL files should have matching dates
		!bat_echolog!   with possibly different times.  The time of the cal file
		!bat_echolog!   should match the time of the FF file chosen for 
		!bat_echolog!   calibration ^(that you wrote down^).
		!bat_echolog!
		!bat_echolog!   This routine should have applied your latest calibration 
		!bat_echolog!   file with the matching date/time in the listed cal filename.
		!bat_echolog!
	!bat_pop!
	
	!bat_echolog!
	!bat_echolog!   FF  file date: !bat_ffname:~6,8!   !bat_ffname!
	!bat_echolog!   Cal file date: !bat_calname:~7,8!   !bat_calname!
	!bat_echolog!

	if /i "!bat_ffname:~6,8!" equ "!bat_calname:~7,8!" (
		!bat_echolog!   So far, they seem to match OK.
		!bat_echolog!
	) else (
		!bat_echolog!   They don't seem to match.
		!bat_echolog!
		if defined bat_autonomous (
			!bat_echolog! ERROR - The calibration was not able to be applied to
			!bat_echolog!         '!bat_detectfile1'. 
			set bat_returncode=1
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	)
	
	!bat_echolog!
	if not defined bat_autonomous (
		set bat_choice=
		set /p bat_choice=.!bat_pushstring!If this is correct, enter [C]ontinue, [R]eject and try again, or [Q]uit : 
		if /i "!bat_choice!" equ "c" goto :APPLYEND
		if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=1
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	) else (
		goto :APPLYEND
	)

:APPLYEND	
!bat_log! [!bat_batchfile!:APPLYEND]

	!bat_logexeclog! move /y "!bat_targetdir!\!bat_detectfile3!C.txt" "!bat_detectfile1!"

:APPLY4
!bat_log! [!bat_batchfile!:APPLY4]
	if exist "!bat_targetdir!\!bat_detectfile3!C.txt" (
		set bat_returncode=1
		!bat_echolog!     ERROR - The {apply} file wasn't able to be moved to the detect file
		!bat_echolog!     "!bat_targetdir!\!bat_detectfile3!C.txt"
		
		if defined bat_autonomous (
			goto :APPLY5
		) else (
			set /p bat_choice=  [C]ontinue, [R]etry, or [Q]uit?  
			if /i "!bat_choice!" equ "c" goto :APPLY5
			if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
			if /i "!bat_choice!" equ "q" (
				set bat_returncode=1
				!bat_log! '    set bat_returncode=!bat_returncode!
				goto :APPLY5
			)
			goto :APPLY4
		)
	) else (
		find /i /c "!bat_calname!" "!bat_detectfile1!">nul:
		if "!errorlevel!" equ "0" (
			!bat_echolog!
			!bat_echolog!   SUCCESS - '!bat_calname!' was applied to '!bat_detectfile1!'
			!bat_echolog!
			set bat_returncode=0
			!bat_log! '    set bat_returncode=!bat_returncode!
		) else (
			!bat_echolog!
			!bat_echolog!   ERROR - '!bat_calname!' was NOT applied to '!bat_detectfile1!'
			!bat_echolog!
			set bat_returncode=1
			!bat_log! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	)

:APPLY5
!bat_poplog! [RETURN !bat_batchfile!:APPLYBEGIN] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!





:GETDETECTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_returncode=0
	set bat_detectfile_temp=

	!bat_logexeclog! call "GetDetectFile.bat" "bat_detectfile" "bat_archivedfilesdir"
	if not exist "!bat_detectfile!" (
			set bat_returncode=2
			!bat_echolog! '     Not found: "!bat_archivedfilesdir!\FTPdetectinfo_0*.txt"
			goto :GETDETECTFILE_END
	)


	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile!" /a-d /b /od`) do (
		set bat_detectfile_temp=!bat_archivedfilesdir!\%%~nxa
		set bat_detectfile1=!bat_archivedfilesdir!\%%~nxa
		set bat_detectfile2=%%~nxa
		set bat_detectfile3=%%~na
	)

	if not defined bat_detectfile_temp (
		set bat_returncode=2
		!bat_echolog! '     Not found: "!bat_archivedfilesdir!\FTPdetectinfo_0*.txt"
		goto :GETDETECTFILE_END
	)


	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	if exist "!bat_GCFC_tempfile!" (
		rem del /q "!bat_GCFC_tempfile!"
	)

	call "!bat_exedir!\GetCameraList.bat" "!bat_GCFC_tempfile!"
	set bat_returncode=0

:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, 
!bat_log! '                                        bat_camera=!bat_camera!, 
!bat_log! '                                        bat_camera_list=!bat_camera_list!, 
!bat_log! '                                        bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!


	rem Checks to see if the camera in arg1 exists in the GCFC.log file
	rem Returns: bat_GCFC_found=true if the camera is found
:CHECK_GCFC
rem !bat_pushlog! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!"`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
rem !bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
!bat_return!




:GETCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*

	set bat_camera_list=
	for /f "usebackq tokens=*" %%a in (`type "!bat_GCFC_tempfile!"`) do (
		if not defined bat_camera_list (
			set bat_camera_list=0!%%a
		) else (
			set bat_camera_list=!bat_camera_list!0%%a
		)
	)

:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] [bat_cameralist=!bat_cameralist!]
!bat_log!
!bat_return!





:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_logexeclog! call "!bat_exedir!\Readini.bat" "!bat_configfile!" "CAMSMENU" bat_capturedfilesdir /q
	if !bat_logexec_returncode! equ 0 (
		set bat_capturedfilesdir=!RetVal1!
	)

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [!bat_capturedfilesdir!]
!bat_log!
!bat_return!











:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1^) Run FTP_ApplyCal2Detectinfo 
	echo       2^) Test the resulting FTPdetectinfoC.txt for proper cal
	echo       3^) Move the resulting FTPdetectinfoC.txt
	echo       4^) Test the resulting FTPdetectinfo.txt for proper cal
exit /b



:DONE
	!bat_popecho! goto !bat_batchfile!:DONE [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	exit /b !bat_returncode!
