  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	rem set bat_pushstring=


	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_startlocation!\Logs\GetDetectFile.bat.log
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_pushecho! [!date! !time!] - !bat_batchfile! %*
	
	call :READPARAMS

	call :DISPLAYCAMERALIST
	
	set bat_returncode=0

goto :GETDETECTFILE %*




:GETDETECTFILE [in] "bat_detectfile" "bat_archivedfilesdir"
!bat_log! [GOTO !bat_batchfile!:GETDETECTFILE] %*

	if not defined %~2 (
		set bat_returncode=1
		!bat_log! '    ERROR 1 - No dir specified in argument 2
		goto :GETDETECTFILE_END
	)

		rem Results in bat_temp having a dirname, such as: "2012_08_11_03_42_01"
	set bat_temp=
	call :PARSETEMP "!%~2!"

		rem The bat_captureddate can be appropriately derrived this way and
		rem it will be used later in this routine.
	if not defined bat_captureddate (
		if defined %~2 (
			set bat_captureddate=!bat_temp:~0,10!
		) else (
			set bat_returncode=2
			!bat_log! '    ERROR 2 - Argument 2 [%~2] is not defined in the calling script.
			goto :GETDETECTFILE_END
		)
	)

		rem The bat_archivedtime can be appropriately derrived this way and
		rem it will be used later in this routine.
	if not defined bat_archivedtime (
		if defined %~2 (
			set bat_archivedtime=!bat_temp:~11,8!
		) else (
			set bat_returncode=3
			!bat_log! '    ERROR 2 - Argument 2 [%~2] is not defined in the calling script.
			goto :GETDETECTFILE_END
		)
	)

	
	set %~1=
	set bat_detectfile1=
	set bat_detectfile2=
	set bat_detectfile3=
	set bat_detectfile4=

	!bat_pushlog! if exist "!%~2!\FTPdetectinfo_0*.txt" ^(
	if               exist "!%~2!\FTPdetectinfo_0*.txt"  (
		!bat_log!
		!bat_log! 'Note: The following FOR loop is sorted in ascending date order so that
		!bat_log! '      the last item in the list is the most recently created detect file.
		!bat_pushlog! for /f "usebackq tokens=*"   a in ^(`dir "!%~2!\FTPdetectinfo_0*.txt" /b /od /a-d`^) do ^(
		for               /f "usebackq tokens=*" %%a in  (`dir "!%~2!\FTPdetectinfo_0*.txt" /b /od /a-d`) do (
			!bat_log! %%~a
			set bat_detectfile1=!%~2!\%%~nxa
			set bat_detectfile2=%%~nxa
			set bat_detectfile3=%%~na
			set bat_detectfile4=!%~2!\%%~nxa
			set %~1=!bat_detectfile1!
		)
		!bat_poplog!
	) else (
		set bat_returncode=4
		!bat_log! '    ERROR 4 - Can't find detect file in [%~2="!%~2!"]
		!bat_log! '    NO DETECT FILES FOUND IN: "!%~2!"
		goto :GETDETECTFILE_END
	)
	!bat_poplog!

	if defined bat_detectfile2 (
		!bat_push!
		!bat_log! Note: The following loop parses the detect file name to see what the
		!bat_log! '       format of the file name is.  If it's an old format, it will be
		!bat_log! '       converted to the new format.
		for /f "usebackq tokens=1-12 delims=_." %%a in ('!bat_detectfile2!') do (
			if /i "%%b" equ "txt" (
				set bat_detectfile3=FTPdetectinfo_!bat_cameralist!_!bat_captureddate!_!bat_archivedtime!
				set bat_detectfile2=!bat_detectfile3!.txt
				set %~1=!%~2!\!bat_detectfile2!
				set bat_detectfile4=!%~1!
				!bat_log! '  It's in this format: FTPdetectinfo.txt
				!bat_log! '    RENAMING to: !bat_detectfile2!
				!bat_log! '      move /y "!bat_detectfile1!" "!%~1!"
									 move /y "!bat_detectfile1!" "!%~1!"
				
			) else (
				if /i "%%f" equ "txt" (
					set bat_detectfile3=FTPdetectinfo_!bat_cameralist!_!bat_captureddate!_!bat_archivedtime!
					set bat_detectfile2=!bat_detectfile3!.txt
					set bat_detectfile4=!%~2!\!bat_detectfile2!
					set %~1=!bat_detectfile4!
					!bat_log! '  It's in this format: FTPdetectinfo_CCCC_YYYY_MM_DD.txt
					!bat_log! '    RENAMING to: !bat_detectfile2!
					!bat_log! '      move /y "!bat_detectfile1!" "!%~1!"
										 move /y "!bat_detectfile1!" "!%~1!"
				) else (
					!bat_log! '  It's in this format: FTPdetectinfo_CCCC_YYYY_MM_DD_hh_mm_ss.txt
					!bat_log! '    No conversion necessary.
				)
			)
			rem set bat_detectfile4=!bat_detectfile4!_!bat_archivedtime!
		)
		!bat_pop!
	) else (
		set bat_returncode=5
		goto :GETDETECTFILE_END
	)


:GETDETECTFILE_END
	!bat_poplog! Returning value in the [%~1] variable using ENDLOCAL:
	!bat_echolog! [ENDLOCAL-!bat_batchfile!:GETDETECTFILE] [%~1=!%~1!]
	!bat_echolog! EXIT /B !bat_returncode!
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_log!
	ENDLOCAL & IF "%~1" NEQ "" (
		SET %~1=%bat_detectfile4%
		set bat_errorlevel=%bat_returncode%
	) ELSE (echo.%bat_detectfile4%)
EXIT /B !bat_returncode!





:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_return!



	rem Parses the specified path [like "bat_archivedfilesdir"] and extracts
	rem just the directory name of the last directory in the path.  For example:
	rem   C:\CAMS\ArchivedFiles\2012_08_11_03_42_01
	rem results in:
	rem   2012_08_11_03_42_01
	rem 
	rem Note: The value must be assigned by the calling batch file.
:PARSETEMP
!bat_pushlog! [CALL !bat_batchfile!:PARSETEMP] %*
	set bat_temp=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:PARSETEMP] [!bat_temp!]
!bat_log!
!bat_return!



	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

		rem Display the list of cameras...
	!bat_log! CAM1 CAM2 CAM3 CAM4
	set bat_cameralist=
	for /f "usebackq tokens=1-4" %%a in ('!bat_CAPTURE.cameralist!') do (
		!bat_log! %%a, %%b, %%c, %%d
		if /i "%%a" neq "" (
			set bat_cameralist=0%%a
		)
		if /i "%%b" neq "" (
			set bat_cameralist=!bat_cameralist!0%%b
		)
		if /i "%%c" neq "" (
			set bat_cameralist=!bat_cameralist!0%%c
		)
		if /i "%%d" neq "" (
			set bat_cameralist=!bat_cameralist!0%%d
		)
	)
:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [!bat_cameralist!]
!bat_log!
!bat_return!



	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed:
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_log! call "!bat_exedir!\ReadParams.bat"
	          CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "bat_detectfile" "bat_archivedfilesdir"
	echo.
	echo Returns the detect file found in the given directory in the second
	echo argument.  If found, the full path/filename is returned in the 
	echo environment variable passed as the first argument. 
	echo.
	echo Example 1:
	echo    set bat_archivedfilesdir=c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfile"     "bat_archivedfilesdir"
	echo Results: bat_detectfile=
	echo    "c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Example 2:
	echo    set bat_confirmedfilesdir=c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfileconf" "bat_confirmedfilesdir"
	echo Results: bat_detectfile=
	echo    c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Notice how the environment variable names are passed an not their
	echo values.  
	echo.
exit /b 9



:DONE
