@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	if "%~1" equ "" goto :HELP
goto :SETUP


:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"

	!bat_echolog! ========================================================================
	!bat_echolog! [%date% %time%] %~0 %*
	!bat_pushecho!

	set bat_archivedfilesdir=%~1
	set bat_targetdir=!bat_archivedfilesdir!
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! '    ERROR - MergeCaseFiles.bat - Invalid path ["!bat_targetdir!"]
		goto :DONE
	)

goto :MAIN %*




:MAIN
!bat_echolog! [GOTO !bat_batchfile!:MAIN] %*
	call :TARGETDIR %*
	if /i "!bat_retval!" equ "failed" (goto :MAIN_END)

	call :WAITFORMULTISCAN %*
	call :TEMPCONCAT %*
	call :GETMETEORCOUNT %*
	call :REBUILDHEADER %*
	call :CONCATFINAL %*
	call :PREVIEW %*
	call :VALIDATE01B %*

:MAIN_END
!bat_echolog! [END-!bat_batchfile!:MAIN] []
!bat_echolog!
goto :DONE




:TARGETDIR
!bat_pushecho! [CALL !bat_batchfile!:TARGETDIR] %* [!bat_camera!, !bat_detectfile!]
	
	set bat_retval=failed

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	
	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	
	rem Parse the string "C:\CAMS\ArchivedFiles\2012_08_11_08_30_39" 
	rem to "2012_08_11_08_30_39"
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^('!bat_targetdir!'^) do ^(
	for               /f "usebackq tokens=*" %%a in ('!bat_targetdir!') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
		set bat_archtime=!bat_archdirname:~11,8!
	)
	
	set bat_captureddate=!bat_dirdate!
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!

	!bat_echolog!     bat_targetdir=!bat_targetdir!
	!bat_echolog!     bat_targetdrive=!bat_targetdrive!
	!bat_echolog!     bat_outputfile=!bat_outputfile!
	!bat_echolog!     bat_exedir=!bat_exedir!
	!bat_echolog!     bat_dirdate=!bat_dirdate!
	!bat_echolog!     bat_currdate=!bat_currdate!
	!bat_echolog!     bat_caldate=!bat_caldate!

	if /i "!bat_targetdir!" equ "" (
		!bat_echolog!
		!bat_echolog! The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		!bat_echolog! Right now, it is set to [bat_targetdir="!bat_targetdir!"].
		!bat_echolog!
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

	rem if not defined bat_detectfile (
		set bat_detectfile_temp=!bat_archivedfilesdir!\FTPdetectinfo_Case???.txt
		!bat_echolog! if not exist "!bat_detectfile_temp!" ^(
		if not exist "!bat_detectfile_temp!" (
			!bat_echolog! '    ERROR - Missing detect file [FTPdetectinfo_Case???.txt] from "!bat_archivedfilesdir!"
			goto :TARGETDIR_END
		)

		for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile_temp!" /a-d /b /o-n`) do (
			set bat_detectfile_temp=!bat_archivedfilesdir!\%%~nxa
		)

		set bat_detectfile=!bat_detectfile_temp!

		if "!bat_capturedfilesdir!" equ "" (
			!bat_echolog!
			!bat_echolog! '    !bat_batchfile!:TARGETDIR
			!bat_echolog! '    ERROR - bat_capturedfilesdir is not set
			!bat_echolog!
			goto :TARGETDIR_END
		)

		set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
		if exist "!bat_GCFC_tempfile!" (
			rem del /q "!bat_GCFC_tempfile!"
		)



		rem set bat_camera=
		set bat_camera_temp=
		set bat_camera_prev=
		set bat_camera_list=
		rem if not defined bat_camera (
			!bat_pushecho! for /f "usebackq tokens=* delims=: skip=2" ..a in ^(`find /i ".bin" "!bat_detectfile!"`^) do ^(
			for                /f "usebackq tokens=* delims=: skip=2" %%a in  (`find /i ".bin" "!bat_detectfile!"`) do (
rem				echo %%~na
				set bat_temp=%%~na
				set bat_camera_temp=!bat_temp:~2,3!
				if /i "!bat_camera_prev!" neq "!bat_camera_temp!" (
					if not defined bat_camera_list (
						echo '      a        set bat_camera_list=0!bat_camera_temp!
						set bat_camera_list=0!bat_camera_temp!
						set bat_camera_prev=!bat_camera_temp!
						echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"
					) else (
						call :CHECK_GCFC "!bat_camera_temp!"
						if not defined bat_GCFC_found (
							echo '      c        set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
							set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
							set bat_camera_prev=!bat_camera_temp!
							echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"

						)
					)

					if not defined bat_camera (
						set bat_camera=!bat_camera_temp!
						echo 'b    set bat_camera=!bat_camera_temp!
					)

				)
			)
			!bat_popecho!
		rem )
	rem )

	
	
	set bat_retval=success

:TARGETDIR_END
!bat_popecho! [RETURN !bat_batchfile!:TARGETDIR] [!bat_retval!, !bat_camera!, !bat_camera_list!, !bat_detectfile!]
rem if /i "!bat_SIMULATION.enabled!" equ "true" (set /p bat_choice=Simulation - Press Enter to continue...)
!bat_echolog!
!bat_return!



:CHECK_GCFC
rem !bat_pushecho! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!"`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
rem !bat_popecho! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
rem !bat_echolog!
!bat_return!





:WAITFORMULTISCAN
!bat_pushecho! [CALL !bat_batchfile!:WAITFORMULTISCAN] %*
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`) do (
		!bat_echolog! Waiting for FTP_Reprocess to release the file: "%bat_targetdir%\%%~nxa"
		!bat_echolog! call WaitForFile rw "%bat_targetdir%\%%~nxa"
		for /f "usebackq tokens=*" %%a in (`call WaitForFile rw "%bat_targetdir%\%%~nxa"`) do (
			!bat_echolog! '    %%a
		)
	)

	!bat_echolog!

:WAITFORMULTISCAN_END
!bat_popecho! [RETURN !bat_batchfile!:WAITFORMULTISCAN] %*
!bat_echolog!
!bat_return!




	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
!bat_pushecho! [CALL !bat_batchfile!:TEMPCONCAT] %* [bat_targetdir=!bat_targetdir!]

	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\FTPdetectinfo_case???.txt" /b /a-d /on`^) do ...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\FTPdetectinfo_case???.txt" /b /a-d /on`) do (
		set /a bat_linecount+=1
		!bat_echolog! !bat_linecount!.  %%a

		if "!bat_linecount!" equ "1" (
			set bat_string="!bat_targetdir!\%%~a"
		) else (
			set bat_string=!bat_string!+"!bat_targetdir!\%%~a"
		)
	)
	!bat_popecho! ^)

	rem If two cameras, then concat with the camera list
	!bat_pushecho! if /i "!bat_camera_list:~4,1!" neq "0" ^(
	if               /i "!bat_camera_list:~4,1!" neq "0"  (
		rem Only one camera
		set bat_detectfile=!bat_targetdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!_!bat_archtime!.txt
		!bat_echolog! copy /y /b !bat_string! "!bat_detectfile!"
		for /f "usebackq tokens=*" %%a in (`copy /y /b !bat_string! "!bat_detectfile!"`) do (
			!bat_echolog! '      %%a
		)
	) else (
		rem Two cameras
		set bat_detectfile=!bat_targetdir!\FTPdetectinfo_!bat_camera_list!_!bat_captureddate!_!bat_archtime!.txt
		!bat_echolog! copy /y /b !bat_string! "!bat_detectfile!"
		for /f "useback tokens=*" %%a in (`copy /y /b !bat_string! "!bat_detectfile!"`) do (
			!bat_echolog! '        %%a
		)
		
		!bat_echolog!
		!bat_echolog! '    detect file: [!bat_detectfile!]
		!bat_echolog!
	)
	
	!bat_popecho! ^)

:TEMPCONCAT_END
!bat_popecho! [RETURN !bat_batchfile!:TEMPCONCAT] [detectfile=!bat_detectfile!,
!bat_echolog! '                                         Copy String=!bat_string!]
rem if /i "!bat_SIMULATION.enabled!" equ "true" (set /p bat_choice=Simulation - Press Enter to continue...)
!bat_echolog!
!bat_return!










:GETDETECTFILE
!bat_pushecho! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_detectfile=
	rem Iterate through all the FTPdetectinfo files in the archivedfiles dir by date/time.
	rem Problem is, it may not have produced a new detect file... 
	rem
	rem CAUTION: You must remember that there are several kinds of detect files that
	rem          could exist:
	rem            FTPdetectinfo_02130216_2012_08_13.txt (from FTP_CaptureTwoAndDetect.exe)
	rem            FTPdetectinfo_02130216_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13.txt (from older scripts)
	rem            FTPdetectinfo.txt (from real old exe and scripts)
	if exist "!bat_archiveddir!\FTPdetectinfo*.txt" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\FTPdetectinfo_0*.txt" /b /a-d /od`) do (
			set bat_temp=%%~nxa

			rem Skip if it's a conincidence file
			if /i "!bat_temp!" neq "FTPdetectinfoCoinc.txt" (

				rem Skip if it's from FTP_ApplyCal2detectinfo.exe
				if /i "!bat_temp:~-5" neq "C.txt" (
					set bat_detectfile=!bat_archiveddir!\%%~nxa
					set bat_detectfile3=%%~na
					set bat_detectfile4=%%~nxa
				)
			)
		)
	)

	if not defined bat_detectfile (
		!bat_echolog! '    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	)

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	)
	
:GETDETECTFILE_END
!bat_popecho! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_detectfile=!bat_detectfile!]
!bat_echolog!
!bat_return!









	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETMETEORCOUNT] []
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "!bat_detectfile!"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
:GETMETEORCOUNT
!bat_popecho! [CALL !bat_batchfile!:GETMETEORCOUNT] [!bat_count!]
!bat_echolog!
!bat_return!





	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
!bat_pushecho! [CALL !bat_batchfile!:REBUILDHEADER] [%*]
	!bat_echolog! bat_outputfile=!bat_outputfile!
	type "!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
	echo.

	set /a bat_linecount=0
	!bat_pushecho! for /f "usebackq tokens=*" %%a in ^(`type "!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"`^) do ^(
	for                /f "usebackq tokens=*" %%a in  (`type "!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_archivedfilesdir!\
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_exedir!\Cal\
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
	!bat_popecho! ^)

:REBUILDHEADER_END
!bat_popecho! [RETURN !bat_batchfile!:REBUILDHEADER] [Meteor Count = !bat_count!, "!bat_outputfile!"]
rem if /i "!bat_SIMULATION.enabled!" equ "true" (set /p bat_choice=Simulation - Press Enter to continue...)
!bat_echolog!
!bat_return!




:CONCATFINAL
!bat_pushecho! [CALL !bat_batchfile!:CONCATFINAL] [!bat_outputfile!, !bat_string!, !bat_detectfile!]
	!bat_pushecho! copy /y /b "!bat_outputfile!"+!bat_string! "!bat_detectfile!"
	for /f "usebackq tokens=*" %%a in (`copy /y /b "!bat_outputfile!"+!bat_string! "!bat_detectfile!"`) do (
		!bat_echolog! '      %%a
	)
	!!bat_popecho!


	!bat_logexec! del "!bat_outputfile!"
	!bat_echolog!

	if not exist "!bat_detectfile!" (
:CONCATPROMPT
		!bat_echolog!
		!bat_echolog! Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		!bat_echolog! file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		!bat_echolog! the following command:
		!bat_echolog! %~0 %*
		!bat_echolog!
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_popecho! [RETURN !bat_batchfile!:CONCATFINAL] [bat_detectfile=!bat_detectfile!]
!bat_echolog!
!bat_return!



:PREVIEW
	!bat_pushecho!
	!bat_echolog! '     Date/Time           Size           File name
	!bat_echolog! '     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile!" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		!bat_echolog! '     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	!bat_echolog!

	!bat_echolog! '    Excerpt from "!bat_detectfile!". Please review the
	!bat_echolog! '    information obtained from the "!bat_detectfile!" file: 
	!bat_echolog! '       - Meteor Count   [should be !bat_count!]
	!bat_echolog! '       - FF folder      [should be "!bat_targetdir!"]
	!bat_echolog! '       - CAL folder     [should match the drive and dir where your Cal files are stored]
	!bat_echolog! '       - Cal file       [May not be correct, if not, Don't skip the Apply process]
	!bat_echolog!
	!bat_echolog! '    Please wait while opening and displaying the first 14 lines from 
	!bat_echolog! '    the "!bat_detectfile!" file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_detectfile!"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			!bat_echolog! '         %%a
		) else (
			if !bat_counter! equ 15 (
				!bat_echolog!
				!bat_echolog! '     Please wait while skipping the rest of the file... [!time!]
			)
		)
	)

:CONCATDISPLAY
:PREVIEW_END
!bat_popecho!
%bat_return%


:VALIDATE01B
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! '    The Cal file's date/time might be from a different date, depending on
	!bat_echolog! '    where you are in the process or how many times you have gone through the
	!bat_echolog! '    process.  The Cal file's date/time is showing the date/time of a recent
	!bat_echolog! '    calibration, which may be a previous day.  
	!bat_echolog!
%bat_return%








:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     Output:
	echo        "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22\FTPdetectinfo_0ccc_2011_10_21.txt"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Merge the multiple file created by MakeCaseListing.bat,
	echo          such as FTPdetectinfo_CaseHeader.txt plus the multiple 
	echo          FTPdetecinfo_Case_001,002... files into a single
	echo          FTPdetectinfo.txt file.
	echo.
	echo       2) Count the number of events in the merged file and
	echo          patch the "Meteor Count = 000000" value with the
	echo          correct value
exit /b



:DONE
!bat_popecho! !bat_batchfile!:DONE
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_log!
