@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:SETUP
	if "%~1" equ "" goto :HELP
	
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"

        rem This routine parses out the elements of a directory or full file name
        rem and path and returns the last segment (either the filename or the last
        rem directory name) as well as the parent path. It removes the trailing 
        rem backslash from everything also.  It is designed to be called several
        rem times as needed (where you'd pass !bat_retval1! as the argument in
        rem subsequent calls) to further parse everything out. 
        rem
        rem This example will explain the two output variables:
        rem    arg1=c:\cams\archivedfiles\2012_02_07_02_43_36\
        rem    bat_retval1=c:\cams\archivedfiles
        rem    bat_retval2=2012_02_07_02_43_36
        rem
:PARSEDIR [in] c:\cams\archivedfiles\2012_02_07_02_43_36\ [out] c:\cams\archivedfiles 
!bat_pushlog! [CALL !bat_batchfile!:PARSEDIR] [in] c:\cams\archivedfiles\{datedir}\FTPdetectinfo.txt [out] c:\cams\archivedfiles{datedir}
        !bat_log! [in] "%~1" 
        
        set bat_out1=%~1
        set bat_out2=%~2
 
        set bat_retval=
        set bat_retval1=
        set bat_retval2=
        
        rem If the entire directory is pointing to the root drive letter of
        rem a dir, there is nothing to parse. The bat_retval1 and bat_retval2
        rem variables will be undefined.  
        if /i "%~3" equ "!bat_targetdrive!" goto :PARSEDIR_END

        set bat_retval1=%~dp3::
        set bat_retval1=!bat_retval1:\::=!
        set bat_retval1=!bat_retval1:::=!
        set bat_retval2=%~nx3

        !bat_log! [out=bat_retval1] "!bat_retval1!"
        !bat_log! [out=bat_retval2] "!bat_retval2!"
:PARSEDIR_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEDIR] [%~1=!bat_retval1!, %~2=!bat_retval2!]
!bat_log!
	( ENDLOCAL & REM RETURN VALUES
	    SET %~1=%bat_retval1%
	    set %~2=%bat_retval2%
	)
exit /b 0


:HELP
	echo %~nx0
	echo.
	echo Usage: %~n0 "basepath" "dirname" "path"
	echo.
	echo Where:
	echo       basepath     - The result of stripping off the last dir/file name
	echo                      from the path [for example C:\CAMS\ArchivedFiles]
	echo       dirname      - The last dir/file name from the given path
	echo                      [for example 2012_08_11_02_43_55]
	echo       path         - The full path that you want to parse. 
	echo                      [For example C:\CAMS\ArchivedFiles\2012_08_11_02_43_55\
	echo.
	echo Note: It works with or without the trailing backslash.
	echo.
exit /b 9



