@echo off
setlocal enabledelayedexpansion enableextensions

:SETUP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP


	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	!bat_pushlog! =======================================================
	!bat_log! %~dpnx0 %*
	!bat_log! bat_logfile=!bat_logfile!

	set bat_caldir=!bat_exedir!\Cal

	set bat_targetfilespec=!bat_caldir!\CAL???_*.txt

	if /i "%~1" EQU "/cal" (
		if "%~2" equ "" (
			!BAT_ECHOLOG! '    ERROR - /cal option is used but the target cal file is blank
			goto :DONE
		)

		set bat_targetfilespec=!bat_caldir!\%~nx2
		call :GETFILENAME "!bat_targetfilespec!"
		set bat_camera=!bat_retval:~3,3!
		shift
		shift
	)

	rem set bat_starcountthreshold=50
	call :READPARAMS

	set bat_starcountthreshold0=000!bat_starcountthreshold!
	set bat_starcountthreshold0=!bat_starcountthreshold0:~-3!
	set bat_delcommand=%~1

	set bat_suffixargs=%1 %2 %3 %4 %5 %6 %7 %8 %9

:MAIN
!bat_pushlog! call !bat_batchfile!:MAIN %*
!bat_log! bat_targetfilespec=!bat_targetfilespec!

	!bat_log! for /f "usebackq tokens=*" ..a in  ^(`dir "!bat_targetfilespec!" /b /a-d][sort /r`^) do ^(
	for           /f "usebackq tokens=*" %%a in   (`dir "!bat_targetfilespec!" /b /a-d^|sort /r`) do (
		set /a bat_count=0
		set /a bat_foundstar=0
		set bat_calfile=!bat_exedir!\Cal\%%~a

		rem count stars
		!bat_pushlog! for /f "usebackq tokens=1-6" ..k in ^(`type "!bat_calfile!"`^) do ^(
		for               /f "usebackq tokens=1-6" %%k in  (`type "!bat_calfile!"`) do (
			call :GETTIME "%%k %%l %%m" "%%o"
			call :GETRA  "%%k %%l %%m %%n" "%%p"
			call :GETDEC "%%k %%l %%m %%n" "%%p"
			call :GETALT "%%k %%l %%m %%n" "%%p"
			call :GETAZ "%%k %%l %%m %%n" "%%p"
			call :GETSCALE "%%k %%l" "%%o"
			set bat_starcount3=000%%k
			set bat_starcount3=!bat_starcount3:~-3!
			set bat_starcount2=%%k
		)
		!bat_poplog!

		rem Find "Mean O-C ="
		!bat_pushlog! for /f "usebackq tokens=1-9" ..b in ^(`type "!bat_calfile!"][find /i "Mean O-C ="`^) do ^(
		for               /f "usebackq tokens=1-9" %%b in  (`type "!bat_calfile!"^|find /i "Mean O-C ="`) do (
			set bat_meanoc=%%e
			set bat_meanoctest=!bat_meanoc:~0,2!
			!bat_echolog! %%~nxa, [Cal stars=!bat_starcount2!] %%c%%d%%e%%f%%g Scale=!bat_scale! [ALT=!bat_ALT! AZ=!bat_AZ!] [RA=!bat_temp6! DEC=!bat_DEC!]

			if "!bat_starcount3!" lss "!bat_starcountthreshold0!" (
				!bat_echolog! Calibration stars !bat_starcount2! less than !bat_starcountthreshold!.  Mean O-C =%%e    %%a
			)
			
			if "!bat_meanoc!" gtr "!bat_caloc!" (
				!bat_echolog!        Mean O-C %%e ^>= !bat_caloc!   "!bat_calfile!"
				if "!bat_delcommand!" neq "" (
					!bat_logexec! !bat_delcommand! "!bat_calfile!" !bat_suffixargs!
				)
			)
		)
		!bat_poplog!
		

	)
	!bat_poplog!
	set bat_retval3=%bat_time%


:MAIN_END
!bat_poplog! return-!bat_batchfile!:MAIN [set bat_retval1=%bat_temp6%, set bat_retval2=%bat_DEC%, set bat_retval3=%bat_time%]
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	ENDLOCAL  & if "%bat_temp6%" NEQ ""  (set bat_retval1=%bat_temp6%&set bat_retval2=%bat_DEC%&set bat_retval3=%bat_time%) else (echo %bat_temp6%, %bat_DEC%, !bat_time%)
exit /b 0


:GETFILENAME
	set bat_retval=%~nx1
goto :EOF

:GETTIME 
	if /i "%~1" neq "Calibration time (UT)" (
		goto :GETTIME_END
	)
	
	set bat_time=%~2
	set bat_time=!bat_time:~0,8!

:GETTIME_END
rem echo [RETURN !bat_batchfile!:GETTIME] [bat_time=!bat_time!]
!bat_return!


	rem Translate the RA from decimal format [337.182] to hour format
	rem [22.3788].  
:GETRA
	if /i "%~1" neq "Cal center RA (deg)" (
		goto :GETRA3
	)
	
:GETRA2
rem echo :GETRA "%~1" "%~2"
rem 	echo for /f "delims=. tokens=1,2" %%x in ("%~2") do...
	for      /f "delims=. tokens=1,2" %%x in ("%~2") do (
		rem echo %%x, %%y
		set bat_retval=%%x
		call :STRIPZEROS bat_retval
		set /a bat_tempL=!bat_retval!*10000
		set bat_retval=%%y
		set bat_zeros=
		if "!bat_retval:~0,3!" equ "000" (
			set bat_retval=0
		) else (
			if "!bat_retval:~0,2!" equ "00" (
				set bat_zeros=00
				set bat_retval=!bat_retval:~2,1!
			) else (
				if "!bat_retval:~0,1!" equ "0" (
					set bat_zeros=0
					set bat_retval=!bat_retval:~1,2!
				)
			)
		)
		rem call :STRIPZEROS bat_retval
		set /a bat_tempR=!bat_retval!*10
	)
	set /a bat_temp1=(!bat_tempL!)
	set /a bat_temp2=(!bat_tempR!+5)
	set /a bat_temp2="bat_temp2 / 10 * 10"
	set /a bat_temp3=!bat_temp1!+!bat_temp2!
	
:GETRALEN
	set bat_temp5=!bat_temp3!
	set /a bat_len=0
	for /l %%z in (0,1,10) do (
		rem echo if "!bat_temp5:~%%z,1!" neq ""...
		if "!bat_temp5:~%%z,1!" neq "" (
			rem echo "!bat_temp5:~%%z, 1!", !bat_len!
			set /a bat_len+=1
		) else (
			rem
		)
	)

	if !bat_len! lss 5 (
		set bat_temp6=000000000!bat_temp3!
		set bat_temp6=00.!bat_temp6:~-4!
	) else (
		set /a bat_len2=!bat_len!-4
		call :GETRA4 bat_temp6 !bat_temp3! !bat_len2!
	)

:GETRA3
!bat_return!



:GETRA4
rem echo call :GETRA4 %*
	set bat_tempra=00!bat_temp3:~0,%~3!
	set bat_temp6=!bat_tempra:~-3!.!bat_temp3:~-4!
!bat_return!


	rem 
:GETDEC
	if /i "%~1" neq "Cal center Dec (deg)" (
		goto :GETDEC3
	)
	
	set bat_DEC=%~2
	
:GETDEC3
!bat_return!


:GETALT
	if /i "%~1" neq "Cal center Elev (deg)" (
		goto :GETALT3
	)
	
	set bat_ALT=%~2
	
:GETALT3
!bat_return!


:GETAZ
	if /i "%~1" neq "Cal center Azim (deg)" (
		goto :GETAZ3
	)
	
	set bat_AZ=%~2
	
:GETAZ3
!bat_return!


:GETSCALE
	if /i "%~1" neq "Plate Scale" (
		goto :GETSCALE_END
	)
	
	set bat_scale=%~2
	
:GETSCALE_END
!bat_return!



	rem strip leading zeros from a number to avoid the Invalid number
	rem error. 
:STRIPZEROS %1
rem echo :STRIPZEROS %1 !%1!
	for /f "tokens=* delims=0" %%Z in ("!%~1!") do (set %~1=%%Z)
	if not defined %~1 set %~1=0
rem echo bat_retval=!bat_retval!
!bat_return!





:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_echolog! call "!bat_exedir!\ReadParams.bat"
				  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!



:HELP
	echo     Usage: %0 [delete command [suffix args]]
	echo.
	echo     This routine iterates through all the files matching this filespec:
	echo        `dir ".\CAL???_*.txt" /s/b /a-d^|sort`
	echo.
	echo     Then, it lists the filename and the Mean O-C number. If the optional
	echo     delete command is used, it will run that delete command. 
	echo.
	echo     CAUTION!  This script can permanently delete some potentially
	echo               unreparable files.
	echo.
	echo     Where 'delete command' is optional and would usually be something
	echo                            like:
	echo                               del /q
	echo.
	echo           'suffix args'    are arguments that would be applied after
	echo                            the others.  
	echo     Example:
	echo        %0 del /q
	echo           would use:   del filename /q
	echo.
	echo        %0 "del /q"
	echo           would use    del /q filename    
	echo        (Note: the quotes are removed from args, but not the filespec)
	echo.
	echo      also:
	echo       %0 /cal CAL299_2012_01_18*.txt
	echo.


exit /b