  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	rem set bat_pushstring=


	set bat_caldir=!bat_exedir!\Cal
	set bat_logfile=!bat_startlocation!\Logs\ZipLogs.bat.log
	
	!bat_log!
	!bat_log! =============================================================
	!bat_pushlog! [!date! !time!] - %~dpnx0 %*

	call :READPARAMS

	if "%~1" equ "" (
		goto :HELP
	)

	set bat_archivedfilesdir=%~1
	set bat_submissionfilesdir=%~2
	set bat_captureddate=%~3
	set bat_capturedtime=%~4
	set bat_camera=%~5

	call :MAIN "!bat_archivedfilesdir!"
goto :DONE





:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] [%*]
	set bat_retval=
	set bat_returncode=0
	
	set bat_archivedfilesdir_name=%~nx1
	!bat_logexeclog! call "!bat_exedir!\ParseDir.bat" "bat_basedir" "bat_basedir_name" "%~1"
	!bat_logexeclog! call "!bat_exedir!\ParseDir.bat" "bat_basedir" "bat_basedir_name" "!bat_basedir!"
	rem !bat_logexeclog! call "!bat_exedir!\ParseDir.bat" "bat_basedir" "bat_basedir_name" "!bat_basedir!"
	set bat_logsdir=!bat_basedir!\Logs

	!bat_logexec! md "!bat_exedir!\Temp\Logs"
	!bat_logexec! md "!bat_exedir!\Temp\Logs\!bat_archivedfilesdir_name!"
	
	!bat_logexec! copy /y "!bat_archivedfilesdir!\*.log" "!bat_exedir!\Temp\Logs\!bat_archivedfilesdir_name!"
	!bat_logexec! copy /y "!bat_logsdir!\*.log" "!bat_exedir!\Temp\Logs"
	
	set bat_zipfile=!bat_exedir!\Temp\Logs\logs_!bat_captureddate!_!bat_camera!_!bat_capturedtime!.zip
	set bat_zipsrc=!bat_exedir!\Temp\Logs\*.log
	
	!bat_echolog! Going to use the zip file: !bat_zipfile!
	!bat_echolog!
	
	if not exist "!bat_zipsrc!" (
		set bat_returncode=99
		set bat_recent_error_msg=ZipLogs. ERROR - Source dir does not exist ["!bat_zipsrc!"]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END		
	)

	!bat_logexec! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
	set bat_returncode=!bat_logexec_returncode!
	
	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=ZipLogs.ERROR - Failed to create the zip file using: "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog! '    errorlevel=!bat_returncode!
		!bat_echolog!
		!bat_echolog! '    Deleting empty zip file...
		!bat_logexec! del /q "!bat_zipfile!"
		goto :MAIN_END		
	)
	
	if exist "!bat_zipfile!" (
			rem Test for empty zip file...
		call :FTPHASH "!bat_zipfile!"
		if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
			set bat_returncode=3
			set bat_recent_error_msg=ZipLogs.ERROR - Empty zip file: "%~1" - deleting the zip file...
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    errorlevel=!bat_returncode!
			!bat_echolog!
			!bat_logexec! del /q "!bat_zipfile!"
		) else (
			set bat_recent_error_msg=ZipLogs.SUCCESS - created "!bat_zipfile!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    Not a blank zip file...
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			set bat_retval=!bat_recent_error_msg!
		)
	)
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\Temp\Logs\*.log" /s/b /on /a-d`) do (
		!bat_logexeclog! del /q "%%a"
	)
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\Temp\Logs" /s/b /on /ad`) do (
		!bat_logexeclog! del /s /q "%%a"
		!bat_logexeclog! rd "%%a"
	)
	
	!bat_echolog!
	!bat_pushecho! The zip file containing the log files is:
	!bat_echolog! "!bat_zipfile!"
	!bat_echolog!

:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_retval!]
!bat_log!
!bat_return!





	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)
	
	if exist "!bat_exedir!\Logs\md5.output.log" (
		!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
	)
	
:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!





:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_echolog! call "!bat_exedir!\ReadParams.bat"
				  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "!bat_archivedfilesdir!"
	echo.
	echo Creates a zip file of the log files in the ArchivedFiles dir as well as
	echo the log files in the ..\Logs dir.
	echo.
exit /b 9



:DONE
!bat_poplog! :DONE with %~f0 %*
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
	) ELSE ( echo.%bat_retval%)
exit /b 0